searchNodes=[{"doc":"Saxy is an XML SAX parser and encoder. Saxy provides functions to parse XML file in both binary and streaming way in compliant with Extensible Markup Language (XML) 1.0 (Fifth Edition) . Saxy also offers DSL and API to build, compose and encode XML document. See &quot;Encoder&quot; section below for more information. Parser Saxy parser supports two modes of parsing: SAX and simple form. SAX mode (Simple API for XML) SAX is an event driven algorithm for parsing XML documents. A SAX parser takes XML document as the input and emits events out to a pre-configured event handler during parsing. There are several types of SAX events supported by Saxy: :start_document - after prolog is parsed. :start_element - when open tag is parsed. :characters - when a chunk of CharData is parsed. :cdata - when a chunk of CData is parsed. :end_element - when end tag is parsed. :end_document - when the root element is closed. See Saxy.Handler for more information. Simple form mode Saxy supports parsing XML documents into a simple format. See Saxy.SimpleForm for more details. Encoding Saxy only supports UTF-8 encoding. It also respects the encoding set in XML document prolog, which means that if the declared encoding is not UTF-8, the parser stops. Anyway, when there is no encoding declared, Saxy defaults the encoding to UTF-8. Reference expansion Saxy supports expanding character references and XML 1.0 predefined entity references, for example &amp;#65; is expanded to &quot;A&quot; , &amp;#x26; to &quot;&amp;&quot; , and &amp;amp; to &quot;&amp;&quot; . Saxy does not expand external entity references, but provides an option to specify how they should be handled. See more in &quot;Shared options&quot; section. Creation of atoms Saxy does not create atoms during the parsing process. DTD and XSD Saxy does not support parsing DTD (Doctype Definition) and XSD schemas. When encountering DTD, the parser simply skips that. Shared options :expand_entity - specifies how external entity references should be handled. Three supported strategies respectively are: :keep - keep the original binary, for example Orange &amp;reg; will be expanded to &quot;Orange &amp;reg;&quot; , this is the default strategy. :skip - skip the original binary, for example Orange &amp;reg; will be expanded to &quot;Orange &quot; . {mod, fun, args} - take the applied result of the specified MFA. :never - keep the original binary, including predefined entity reference, e.g. &quot;Orange &amp;amp;&quot; will remain &quot;Orange &amp;amp;&quot; :cdata_as_characters - true to emit CData events as :characters . Defaults to true . Encoder Saxy offers two APIs to build simple form and encode XML document. Use Saxy.XML to build and compose XML simple form, then Saxy.encode!/2 to encode the built element into XML binary. iex&gt; import Saxy.XML iex&gt; element = element ( &quot;person&quot; , [ gender : &quot;female&quot; ] , &quot;Alice&quot; ) { &quot;person&quot; , [ { &quot;gender&quot; , &quot;female&quot; } ] , [ &quot;Alice&quot; ] } iex&gt; Saxy . encode! ( element , [ version : &quot;1.0&quot; ] ) &quot;&lt;?xml version= \\&quot; 1.0 \\&quot; ?&gt;&lt;person gender= \\&quot; female \\&quot; &gt;Alice&lt;/person&gt;&quot; See Saxy.XML for more XML building APIs. Saxy also provides Saxy.Builder protocol to help composing structs into simple form. defmodule Person do @derive { Saxy.Builder , name : &quot;person&quot; , attributes : [ :gender ] , children : [ :name , emails : &amp; __MODULE__ . build_emails / 1 ] } import Saxy.XML defstruct [ :name , :gender , emails : [ ] ] def build_emails ( emails ) do count = Enum . count ( emails ) element ( &quot;emails&quot; , [ count : Enum . count ( emails ) ] , Enum . map ( emails , &amp; element ( &quot;email&quot; , [ ] , &amp;1 ) ) ) end end iex&gt; jack = % Person { gender : :male , name : &quot;Jack&quot; , emails : [ &quot;john@example.com&quot; ] } iex&gt; john = % Person { gender : :male , name : &quot;John&quot; } iex&gt; import Saxy.XML iex&gt; root = element ( &quot;people&quot; , [ ] , [ jack , john ] ) iex&gt; Saxy . encode! ( root , [ version : &quot;1.0&quot; ] ) &quot;&lt;?xml version= \\&quot; 1.0 \\&quot; ?&gt;&lt;people&gt;&lt;person gender= \\&quot; male \\&quot; &gt;Jack&lt;emails count= \\&quot; 1 \\&quot; &gt;&lt;email&gt;john@example.com&lt;/email&gt;&lt;/emails&gt;&lt;/person&gt;&lt;person gender= \\&quot; male \\&quot; &gt;John&lt;emails count= \\&quot; 0 \\&quot; /&gt;&lt;/person&gt;&lt;/people&gt;&quot;","ref":"Saxy.html","title":"Saxy","type":"module"},{"doc":"Encodes a simple form XML element into string. This function encodes an element in simple form format and a prolog to an XML document. Examples iex&gt; import Saxy.XML iex&gt; root = element ( :foo , [ { &quot;foo&quot; , &quot;bar&quot; } ] , &quot;bar&quot; ) iex&gt; prolog = [ version : &quot;1.0&quot; ] iex&gt; Saxy . encode! ( root , prolog ) &quot;&lt;?xml version= \\&quot; 1.0 \\&quot; ?&gt;&lt;foo foo= \\&quot; bar \\&quot; &gt;bar&lt;/foo&gt;&quot; iex&gt; prolog = [ version : &quot;1.0&quot; , encoding : &quot;UTF-8&quot; ] iex&gt; Saxy . encode! ( root , prolog ) &quot;&lt;?xml version= \\&quot; 1.0 \\&quot; encoding= \\&quot; UTF-8 \\&quot; ?&gt;&lt;foo foo= \\&quot; bar \\&quot; &gt;bar&lt;/foo&gt;&quot;","ref":"Saxy.html#encode!/2","title":"Saxy.encode!/2","type":"function"},{"doc":"Encodes a simple form element into IO data. Same as encode!/2 but this encodes the document into IO data. Examples iex&gt; import Saxy.XML iex&gt; root = element ( :foo , [ { &quot;foo&quot; , &quot;bar&quot; } ] , &quot;bar&quot; ) iex&gt; prolog = [ version : &quot;1.0&quot; ] iex&gt; Saxy . encode_to_iodata! ( root , prolog ) [ [ &#39;&lt;?xml&#39; , [ 32 , &#39;version&#39; , 61 , 34 , &quot;1.0&quot; , 34 ] , [ ] , [ ] , &#39;?&gt;&#39; ] , [ 60 , &quot;foo&quot; , 32 , &quot;foo&quot; , 61 , 34 , &quot;bar&quot; , 34 ] , 62 , [ &quot;bar&quot; ] , [ 60 , 47 , &quot;foo&quot; , 62 ] ]","ref":"Saxy.html#encode_to_iodata!/2","title":"Saxy.encode_to_iodata!/2","type":"function"},{"doc":"Parses XML stream data. This function takes a stream, SAX event handler (see more at Saxy.Handler ) and an initial state as the input, it returns {:ok, state} if parsing is successful, otherwise {:error, exception} , where exception is a Saxy.ParseError struct which can be converted into readable message with Exception.message/1 . Examples defmodule MyTestHandler do @behaviour Saxy.Handler def handle_event ( :start_document , prolog , state ) do { :ok , [ { :start_document , prolog } | state ] } end def handle_event ( :end_document , _data , state ) do { :ok , [ { :end_document } | state ] } end def handle_event ( :start_element , { name , attributes } , state ) do { :ok , [ { :start_element , name , attributes } | state ] } end def handle_event ( :end_element , name , state ) do { :ok , [ { :end_element , name } | state ] } end def handle_event ( :characters , chars , state ) do { :ok , [ { :chacters , chars } | state ] } end end iex&gt; stream = File . stream! ( &quot;./test/support/fixture/foo.xml&quot; ) iex&gt; Saxy . parse_stream ( stream , MyTestHandler , [ ] ) { :ok , [ { :end_document } , { :end_element , &quot;foo&quot; } , { :start_element , &quot;foo&quot; , [ { &quot;bar&quot; , &quot;value&quot; } ] } , { :start_document , [ version : &quot;1.0&quot; ] } ] } Memory usage Saxy.parse_stream/3 takes a File.Stream or Stream as the input, so the amount of bytes to buffer in each chunk can be controlled by File.stream!/3 API. During parsing, the actual memory used by Saxy might be higher than the number configured for each chunk, since Saxy holds in memory some parsed parts of the original binary to leverage Erlang sub-binary extracting. Anyway, Saxy tries to free those up when it makes sense. Options See the “Shared options” section at the module documentation. :character_data_max_length - tells the parser to emit the :characters event when its length exceeds the specified number. The option is useful when the tag being parsed containing a very large chunk of data. Defaults to :infinity .","ref":"Saxy.html#parse_stream/4","title":"Saxy.parse_stream/4","type":"function"},{"doc":"Parses XML binary data. This function takes XML binary, SAX event handler (see more at Saxy.Handler ) and an initial state as the input, it returns {:ok, state} if parsing is successful, otherwise {:error, exception} , where exception is a Saxy.ParseError struct which can be converted into readable message with Exception.message/1 . The third argument state can be used to keep track of data and parsing progress when parsing is happening, which will be returned when parsing finishes. Options See the “Shared options” section at the module documentation. Examples defmodule MyTestHandler do @behaviour Saxy.Handler def handle_event ( :start_document , prolog , state ) do { :ok , [ { :start_document , prolog } | state ] } end def handle_event ( :end_document , _data , state ) do { :ok , [ { :end_document } | state ] } end def handle_event ( :start_element , { name , attributes } , state ) do { :ok , [ { :start_element , name , attributes } | state ] } end def handle_event ( :end_element , name , state ) do { :ok , [ { :end_element , name } | state ] } end def handle_event ( :characters , chars , state ) do { :ok , [ { :chacters , chars } | state ] } end end iex&gt; xml = &quot;&lt;?xml version=&#39;1.0&#39; ?&gt;&lt;foo bar=&#39;value&#39;&gt;&lt;/foo&gt;&quot; iex&gt; Saxy . parse_string ( xml , MyTestHandler , [ ] ) { :ok , [ { :end_document } , { :end_element , &quot;foo&quot; } , { :start_element , &quot;foo&quot; , [ { &quot;bar&quot; , &quot;value&quot; } ] } , { :start_document , [ version : &quot;1.0&quot; ] } ] }","ref":"Saxy.html#parse_string/4","title":"Saxy.parse_string/4","type":"function"},{"doc":"Protocol for building XML content. Deriving This helps to generate XML content simple form in trivial cases. There are a few required options: name - tag name of generated XML element. attributes - struct keys to be encoded as attributes. children - a list of entries to be collected as element content. Each entry could be either: key - value will be used as the content. two-element tuple of key and transformer - struct value will be passed to the transformer. Transformer function could be a captured public function or a tuple of module and function. Examples defmodule Person do @derive { Saxy.Builder , name : &quot;person&quot; , attributes : [ :gender ] , children : [ :name , emails : &amp; __MODULE__ . build_emails / 1 ] } import Saxy.XML defstruct [ :name , :gender , emails : [ ] ] def build_emails ( emails ) do count = Enum . count ( emails ) element ( &quot;emails&quot; , [ count : Enum . count ( emails ) ] , Enum . map ( emails , &amp; element ( &quot;email&quot; , [ ] , &amp;1 ) ) ) end end iex&gt; person = % Person { name : &quot;Alice&quot; , gender : &quot;female&quot; , emails : [ &quot;alice@foo.com&quot; , &quot;alice@bar.com&quot; ] } iex&gt; Saxy.Builder . build ( person ) { &quot;person&quot; , [ { &quot;gender&quot; , &quot;female&quot; } ] , [ &quot;Alice&quot; , { &quot;emails&quot; , [ { &quot;count&quot; , &quot;2&quot; } ] , [ { &quot;email&quot; , [ ] , [ &quot;alice@foo.com&quot; ] } , { &quot;email&quot; , [ ] , [ &quot;alice@bar.com&quot; ] } ] } ] } Custom implementation could be done by implementing protocol: defmodule User do defstruct [ :username , :name ] end defimpl Saxy.Builder , for : User do import Saxy.XML def build ( user ) do element ( &quot;Person&quot; , [ { &quot;userName&quot; , user . username } ] , [ element ( &quot;Name&quot; , [ ] , user . name ) ] ) end end iex&gt; user = % User { name : &quot;Alice&quot; , username : &quot;alice99&quot; } iex&gt; Saxy.Builder . build ( user ) { &quot;Person&quot; , [ { &quot;userName&quot; , &quot;alice99&quot; } ] , [ { &quot;Name&quot; , [ ] , [ &quot;Alice&quot; ] } ] }","ref":"Saxy.Builder.html","title":"Saxy.Builder","type":"protocol"},{"doc":"Builds content to XML content in simple form.","ref":"Saxy.Builder.html#build/1","title":"Saxy.Builder.build/1","type":"function"},{"doc":"","ref":"Saxy.Builder.html#t:t/0","title":"Saxy.Builder.t/0","type":"type"},{"doc":"This module provides callbacks to implement SAX events handler.","ref":"Saxy.Handler.html","title":"Saxy.Handler","type":"behaviour"},{"doc":"Callback for event handling. This callback takes an event type, an event data and user_state as the input. The initial user_state is the third argument in Saxy.parse_string/3 and Saxy.parse_stream/3 . It can be accumulated and passed around during the parsing time by returning it as the result of the callback implementation, which can be used to keep track of data when parsing is happening. Returning {:ok, new_state} continues the parsing process with the new state. Returning {:stop, anything} stops the prosing process immediately, and anything will be returned. This is usually handy when we want to get the desired return without parsing the whole file. Returning {:halt, anything} stops the prosing process immediately, anything will be returned, together with the rest of buffer being parsed. This is usually handy when we want to get the desired return without parsing the whole file. SAX Events There are a couple of events that need to be handled in the handler. :start_document . :start_element . :characters – the binary that matches CharData* and Reference . Note that it is not trimmed and includes ALL whitespace characters that match CharData . :cdata – the binary that matches CData* . :end_document . :end_element . Check out event_data() type for more information of what are emitted for each event type. Examples defmodule MyEventHandler do @behaviour Saxy.Handler def handle_event ( :start_document , prolog , state ) do { :ok , [ { :start_document , prolog } | state ] } end def handle_event ( :end_document , _data , state ) do { :ok , [ { :end_document } | state ] } end def handle_event ( :start_element , { name , attributes } , state ) do { :ok , [ { :start_element , name , attributes } | state ] } end def handle_event ( :end_element , name , state ) do { :ok , [ { :end_element , name } | state ] } end def handle_event ( :characters , chars , state ) do { :ok , [ { :chacters , chars } | state ] } end end","ref":"Saxy.Handler.html#c:handle_event/3","title":"Saxy.Handler.handle_event/3","type":"callback"},{"doc":"","ref":"Saxy.Handler.html#t:cdata_data/0","title":"Saxy.Handler.cdata_data/0","type":"type"},{"doc":"","ref":"Saxy.Handler.html#t:characters_data/0","title":"Saxy.Handler.characters_data/0","type":"type"},{"doc":"","ref":"Saxy.Handler.html#t:end_document_data/0","title":"Saxy.Handler.end_document_data/0","type":"type"},{"doc":"","ref":"Saxy.Handler.html#t:end_element_data/0","title":"Saxy.Handler.end_element_data/0","type":"type"},{"doc":"","ref":"Saxy.Handler.html#t:event_data/0","title":"Saxy.Handler.event_data/0","type":"type"},{"doc":"","ref":"Saxy.Handler.html#t:event_name/0","title":"Saxy.Handler.event_name/0","type":"type"},{"doc":"","ref":"Saxy.Handler.html#t:start_document_data/0","title":"Saxy.Handler.start_document_data/0","type":"type"},{"doc":"","ref":"Saxy.Handler.html#t:start_element_data/0","title":"Saxy.Handler.start_element_data/0","type":"type"},{"doc":"Supports parsing an XML document partially. This module is useful when the XML document cannot be turned into a Stream e.g over sockets. Example iex&gt; { :ok , partial } = Saxy.Partial . new ( StackHandler , [ ] ) iex&gt; { :cont , partial } = Saxy.Partial . parse ( partial , &quot;&lt;foo&gt;&quot; ) iex&gt; { :cont , partial } = Saxy.Partial . parse ( partial , &quot;&lt;/foo&gt;&quot; ) iex&gt; Saxy.Partial . terminate ( partial ) { :ok , [ end_document : { } , end_element : &quot;foo&quot; , start_element : { &quot;foo&quot; , [ ] } , start_document : [ ] ] }","ref":"Saxy.Partial.html","title":"Saxy.Partial","type":"module"},{"doc":"Obtain the state set by the user.","ref":"Saxy.Partial.html#get_state/1","title":"Saxy.Partial.get_state/1","type":"function"},{"doc":"Builds up a Saxy.Partial , which can be used for later parsing.","ref":"Saxy.Partial.html#new/3","title":"Saxy.Partial.new/3","type":"function"},{"doc":"Continue parsing next chunk of the document with a partial. This function can return in 3 ways: {:cont, partial} - The parsing process has not been terminated. {:halt, user_state} - The parsing process has been terminated, usually because of parser stopping. {:halt, user_state, rest} - The parsing process has been terminated, usually because of parser halting. {:error, exception} - The parsing process has erred.","ref":"Saxy.Partial.html#parse/2","title":"Saxy.Partial.parse/2","type":"function"},{"doc":"Same as partial/2, but continue previous parsing with a new, provided state as the third argument instead of the previous accumulated state. i.e. Saxy.Partial.parse(partial, binary, new_state) # coninue previous partial with a new state This function can return in 3 ways: {:cont, partial} - The parsing process has not been terminated. {:halt, user_state} - The parsing process has been terminated, usually because of parser stopping. {:halt, user_state, rest} - The parsing process has been terminated, usually because of parser halting. {:error, exception} - The parsing process has erred.","ref":"Saxy.Partial.html#parse/3","title":"Saxy.Partial.parse/3","type":"function"},{"doc":"Terminates the XML document parsing.","ref":"Saxy.Partial.html#terminate/1","title":"Saxy.Partial.terminate/1","type":"function"},{"doc":"","ref":"Saxy.Partial.html#t:t/0","title":"Saxy.Partial.t/0","type":"opaque"},{"doc":"","ref":"Saxy.Prolog.html","title":"Saxy.Prolog","type":"module"},{"doc":"","ref":"Saxy.Prolog.html#from_keyword/1","title":"Saxy.Prolog.from_keyword/1","type":"function"},{"doc":"","ref":"Saxy.Prolog.html#t:t/0","title":"Saxy.Prolog.t/0","type":"type"},{"doc":"Provides functions to parse a XML document to simple-form data structure. Data structure Simple form is a basic representation of the parsed XML document. It contains a root element, and all elements are in the following format: element = { tag_name , attributes , content } content = ( element | binary | cdata ) * See &quot;Types&quot; section for more information.","ref":"Saxy.SimpleForm.html","title":"Saxy.SimpleForm","type":"module"},{"doc":"Parse given string into simple form. Options :expand_entity - specifies how external entity references should be handled. Three supported strategies respectively are: :keep - keep the original binary, for example Orange &amp;reg; will be expanded to &quot;Orange &amp;reg;&quot; , this is the default strategy. :skip - skip the original binary, for example Orange &amp;reg; will be expanded to &quot;Orange &quot; . {mod, fun, args} - take the applied result of the specified MFA. :never - keep the original binary, including predefined entity reference, e.g. &quot;Orange &amp;amp;&quot; will remain &quot;Orange &amp;amp;&quot; :cdata_as_characters - true to return CData as characters, false to wrap CData as {:cdata, data} . Defaults to true . Note that it is recommended to disable :cdata_as_characters if the outcome simple form data is meant to be re-encoded later. Consider the following example, the encoded document has different sematics from the original one. iex&gt; xml = &quot;&lt;foo&gt;&lt;![CDATA[&lt;greeting&gt;Hello, world!&lt;/greeting&gt;]]&gt;&lt;/foo&gt;&quot; iex&gt; { :ok , simple_form } = Saxy.SimpleForm . parse_string ( xml , cdata_as_characters : true ) { :ok , { &quot;foo&quot; , [ ] , [ &quot;&lt;greeting&gt;Hello, world!&lt;/greeting&gt;&quot; ] } } iex&gt; Saxy . encode! ( simple_form ) &quot;&lt;foo&gt;&lt;greeting&gt;Hello, world!&lt;/greeting&gt;&lt;/foo&gt;&quot; Examples Given this XML document. iex&gt; xml = &quot;&quot;&quot; ...&gt; &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot; ?&gt; ...&gt; &lt;menu&gt; ...&gt; &lt;movie url=&quot;https://www.imdb.com/title/tt0120338/&quot; id=&quot;tt0120338&quot;&gt; ...&gt; &lt;name&gt;Titanic&lt;/name&gt; ...&gt; &lt;characters&gt;Jack &amp;amp; Rose&lt;/characters&gt; ...&gt; &lt;/movie&gt; ...&gt; &lt;movie url=&quot;https://www.imdb.com/title/tt0109830/&quot; id=&quot;tt0109830&quot;&gt; ...&gt; &lt;name&gt;Forest Gump&lt;/name&gt; ...&gt; &lt;characters&gt;Forest &amp;amp; Jenny&lt;/characters&gt; ...&gt; &lt;/movie&gt; ...&gt; &lt;/menu&gt; ...&gt; &quot;&quot;&quot; iex&gt; Saxy.SimpleForm . parse_string ( xml ) { :ok , { &quot;menu&quot; , [ ] , [ &quot; \\n &quot; , { &quot;movie&quot; , [ { &quot;url&quot; , &quot;https://www.imdb.com/title/tt0120338/&quot; } , { &quot;id&quot; , &quot;tt0120338&quot; } ] , [ &quot; \\n &quot; , { &quot;name&quot; , [ ] , [ &quot;Titanic&quot; ] } , &quot; \\n &quot; , { &quot;characters&quot; , [ ] , [ &quot;Jack &amp; Rose&quot; ] } , &quot; \\n &quot; ] } , &quot; \\n &quot; , { &quot;movie&quot; , [ { &quot;url&quot; , &quot;https://www.imdb.com/title/tt0109830/&quot; } , { &quot;id&quot; , &quot;tt0109830&quot; } ] , [ &quot; \\n &quot; , { &quot;name&quot; , [ ] , [ &quot;Forest Gump&quot; ] } , &quot; \\n &quot; , { &quot;characters&quot; , [ ] , [ &quot;Forest &amp; Jenny&quot; ] } , &quot; \\n &quot; ] } , &quot; \\n &quot; ] } }","ref":"Saxy.SimpleForm.html#parse_string/2","title":"Saxy.SimpleForm.parse_string/2","type":"function"},{"doc":"","ref":"Saxy.SimpleForm.html#t:attributes/0","title":"Saxy.SimpleForm.attributes/0","type":"type"},{"doc":"","ref":"Saxy.SimpleForm.html#t:content/0","title":"Saxy.SimpleForm.content/0","type":"type"},{"doc":"","ref":"Saxy.SimpleForm.html#t:t/0","title":"Saxy.SimpleForm.t/0","type":"type"},{"doc":"","ref":"Saxy.SimpleForm.html#t:tag_name/0","title":"Saxy.SimpleForm.tag_name/0","type":"type"},{"doc":"Helper functions for building XML elements.","ref":"Saxy.XML.html","title":"Saxy.XML","type":"module"},{"doc":"Builds CDATA in simple form.","ref":"Saxy.XML.html#cdata/1","title":"Saxy.XML.cdata/1","type":"function"},{"doc":"Builds characters in simple form.","ref":"Saxy.XML.html#characters/1","title":"Saxy.XML.characters/1","type":"function"},{"doc":"Builds comment in simple form.","ref":"Saxy.XML.html#comment/1","title":"Saxy.XML.comment/1","type":"function"},{"doc":"Builds element in simple form.","ref":"Saxy.XML.html#element/3","title":"Saxy.XML.element/3","type":"function"},{"doc":"Builds empty element in simple form.","ref":"Saxy.XML.html#empty_element/2","title":"Saxy.XML.empty_element/2","type":"function"},{"doc":"Builds processing instruction in simple form.","ref":"Saxy.XML.html#processing_instruction/2","title":"Saxy.XML.processing_instruction/2","type":"function"},{"doc":"Builds reference in simple form.","ref":"Saxy.XML.html#reference/2","title":"Saxy.XML.reference/2","type":"function"},{"doc":"","ref":"Saxy.XML.html#t:cdata/0","title":"Saxy.XML.cdata/0","type":"type"},{"doc":"","ref":"Saxy.XML.html#t:characters/0","title":"Saxy.XML.characters/0","type":"type"},{"doc":"","ref":"Saxy.XML.html#t:comment/0","title":"Saxy.XML.comment/0","type":"type"},{"doc":"","ref":"Saxy.XML.html#t:content/0","title":"Saxy.XML.content/0","type":"type"},{"doc":"","ref":"Saxy.XML.html#t:dec_ref/0","title":"Saxy.XML.dec_ref/0","type":"type"},{"doc":"","ref":"Saxy.XML.html#t:element/0","title":"Saxy.XML.element/0","type":"type"},{"doc":"","ref":"Saxy.XML.html#t:entity_ref/0","title":"Saxy.XML.entity_ref/0","type":"type"},{"doc":"","ref":"Saxy.XML.html#t:hex_ref/0","title":"Saxy.XML.hex_ref/0","type":"type"},{"doc":"","ref":"Saxy.XML.html#t:processing_instruction/0","title":"Saxy.XML.processing_instruction/0","type":"type"},{"doc":"","ref":"Saxy.XML.html#t:ref/0","title":"Saxy.XML.ref/0","type":"type"},{"doc":"Returned when parser encounters errors during parsing.","ref":"Saxy.ParseError.html","title":"Saxy.ParseError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Saxy.ParseError.html#message/1","title":"Saxy.ParseError.message/1","type":"function"},{"doc":"","ref":"Saxy.ParseError.html#t:reason/0","title":"Saxy.ParseError.reason/0","type":"type"},{"doc":"","ref":"Saxy.ParseError.html#t:t/0","title":"Saxy.ParseError.t/0","type":"type"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Saxy.encode! now supports &quot;UTF-8&quot;/&quot;utf-8&quot; as string in the prolog #102 . Access user state inside partial to allow streaming output #100 . Introduce :never to expand_entity option #114 . Bug fixes around typespecs.","ref":"changelog.html#v1-5-0-2022-11-09","title":"Changelog - v1.5.0 - 2022-11-09","type":"extras"},{"doc":"Optimize Saxy.parse_string (about 20% faster) #84 . Previously this could be achieved with application config, you no longer have to do that. Support custom transformer in Saxy.Builder #87 . Miscellaneous fixes #81 , #82 , #89 .","ref":"changelog.html#v1-4-0-2021-06-05","title":"Changelog - v1.4.0 - 2021-06-05","type":"extras"},{"doc":"Fix Saxy.Builder primitive type implementations. Add :cdata SAX event type. Introduce :cdata_as_characters option in parsers.","ref":"changelog.html#v1-3-0-2020-10-18","title":"Changelog - v1.3.0 - 2020-10-18","type":"extras"},{"doc":"Bring back accidentally removed XML builders.","ref":"changelog.html#v1-2-2-2020-10-02","title":"Changelog - v1.2.2 - 2020-10-02","type":"extras"},{"doc":"Fix incorrect type spec.","ref":"changelog.html#v1-2-1-2020-09-27-retired","title":"Changelog - v1.2.1 - 2020-09-27 (retired)","type":"extras"},{"doc":"Fix XML encoding without prolog #57 . Fix integer typespec #58 . Introduce parser halting #66 . Speed up XML builder #69 .","ref":"changelog.html#v1-2-0-2020-06-02","title":"Changelog - v1.2.0 - 2020-06-02","type":"extras"},{"doc":"Introduce :character_data_max_length option in stream and partial parsing.","ref":"changelog.html#v1-1-0-2020-02-09","title":"Changelog - v1.1.0 - 2020-02-09","type":"extras"},{"doc":"Support Elixir 1.6+. Fix white spaces emitting bug in empty elements. BREAKING CHANGES: Leading whitespaces before a tag open will be emitted.","ref":"changelog.html#v1-0-0-2019-12-19","title":"Changelog - v1.0.0 - 2019-12-19","type":"extras"},{"doc":"Add support of partial parsing #42 .","ref":"changelog.html#v0-10-0-2019-08-26","title":"Changelog - v0.10.0 - 2019-08-26","type":"extras"},{"doc":"Fix type spec warnings in Saxy.SimpleForm .","ref":"changelog.html#v0-9-1-2019-02-26","title":"Changelog - v0.9.1 - 2019-02-26","type":"extras"},{"doc":"Allow turning off streaming feature in config #30 . Skip DTD instead of crashing #33 . Minor bug fix on element attributes order 09b90a9b50ea3ffa17ba2736c29ff791ff9859d0 .","ref":"changelog.html#v0-9-0-2018-10-21","title":"Changelog - v0.9.0 - 2018-10-21","type":"extras"},{"doc":"Improve streaming parsing #23 . Improve parser performance #24 . Improve parser error handling #25 .","ref":"changelog.html#v0-8-0-2018-09-05","title":"Changelog - v0.8.0 - 2018-09-05","type":"extras"},{"doc":"Introduce XML encoder #17 . Fix wrong ASCII code point matching #20 . Brought back UTF-8 encoding validation ( #16 ).","ref":"changelog.html#v0-7-0-2018-07-14","title":"Changelog - v0.7.0 - 2018-07-14","type":"extras"},{"doc":"Introduce :expand_entity option ( #14 ). Hard deprecate Saxy.Handler.handle_entity_reference/1 callback ( #14 ). Fix a UTF-8 buffering bug for streaming parsing ( #13 , #15 ). Return only root tag in simple form parsing ( e8c062 ).","ref":"changelog.html#v0-6-0-2018-04-08","title":"Changelog - v0.6.0 - 2018-04-08","type":"extras"},{"doc":"Introduce Simple Form parsing. Parse misc after finishing parsing root element.","ref":"changelog.html#v0-5-0-2018-03-15","title":"Changelog - v0.5.0 - 2018-03-15","type":"extras"},{"doc":"Supported Elixir v1.3. Increased parsing speed by 22 times. Improved returning error. Added handle_entity_reference callback in Saxy.Handler . Breaking changes: Required entity reference handling in Saxy.Handler .","ref":"changelog.html#v0-4-0-2018-03-12","title":"Changelog - v0.4.0 - 2018-03-12","type":"extras"},{"doc":"Copyright (c) 2018 Cẩm Huỳnh Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Saxy Saxy (Sá xị) is an XML SAX parser and encoder in Elixir that focuses on speed, usability and standard compliance. Comply with Extensible Markup Language (XML) 1.0 (Fifth Edition) .","ref":"readme.html","title":"Saxy","type":"extras"},{"doc":"An incredibly fast XML 1.0 SAX parser. An extremely fast XML encoder. Native support for streaming parsing large XML files. Parse XML documents into simple DOM format. Support quick returning in event handlers.","ref":"readme.html#features-highlight","title":"Saxy - Features highlight","type":"extras"},{"doc":"Add :saxy to your mix.exs . def deps ( ) do [ { :saxy , &quot;~&gt; 1.5&quot; } ] end","ref":"readme.html#installation","title":"Saxy - Installation","type":"extras"},{"doc":"Full documentation is available on HexDocs . If you never work with a SAX parser before, please check out this guide . SAX parser A SAX event handler implementation is required before starting parsing. defmodule MyEventHandler do @behaviour Saxy.Handler def handle_event ( :start_document , prolog , state ) do IO . inspect ( &quot;Start parsing document&quot; ) { :ok , [ { :start_document , prolog } | state ] } end def handle_event ( :end_document , _data , state ) do IO . inspect ( &quot;Finish parsing document&quot; ) { :ok , [ { :end_document } | state ] } end def handle_event ( :start_element , { name , attributes } , state ) do IO . inspect ( &quot;Start parsing element \#{ name } with attributes \#{ inspect ( attributes ) } &quot; ) { :ok , [ { :start_element , name , attributes } | state ] } end def handle_event ( :end_element , name , state ) do IO . inspect ( &quot;Finish parsing element \#{ name } &quot; ) { :ok , [ { :end_element , name } | state ] } end def handle_event ( :characters , chars , state ) do IO . inspect ( &quot;Receive characters \#{ chars } &quot; ) { :ok , [ { :characters , chars } | state ] } end def handle_event ( :cdata , cdata , state ) do IO . inspect ( &quot;Receive CData \#{ cdata } &quot; ) { :ok , [ { :cdata , cdata } | state ] } end end Then start parsing XML documents with: iex&gt; xml = &quot;&lt;?xml version=&#39;1.0&#39; ?&gt;&lt;foo bar=&#39;value&#39;&gt;&lt;/foo&gt;&quot; iex&gt; Saxy . parse_string ( xml , MyEventHandler , [ ] ) { :ok , [ { :end_document } , { :end_element , &quot;foo&quot; } , { :start_element , &quot;foo&quot; , [ { &quot;bar&quot; , &quot;value&quot; } ] } , { :start_document , [ version : &quot;1.0&quot; ] } ] } Streaming parsing Saxy also accepts file stream as the input: stream = File . stream! ( &quot;/path/to/file&quot; ) Saxy . parse_stream ( stream , MyEventHandler , initial_state ) It even supports parsing a normal stream. stream = File . stream! ( &quot;/path/to/file&quot; ) |&gt; Stream . filter ( &amp; ( &amp;1 != &quot; \\n &quot; ) ) Saxy . parse_stream ( stream , MyEventHandler , initial_state ) Partial parsing Saxy can parse an XML document partially. This feature is useful when the document cannot be turned into a stream e.g receiving over socket. { :ok , partial } = Partial . new ( MyEventHandler , initial_state ) { :cont , partial } = Partial . parse ( partial , &quot;&lt;foo&gt;&quot; ) { :cont , partial } = Partial . parse ( partial , &quot;&lt;bar&gt;&lt;/bar&gt;&quot; ) { :cont , partial } = Partial . parse ( partial , &quot;&lt;/foo&gt;&quot; ) { :ok , state } = Partial . terminate ( partial ) Simple DOM format exporting Sometimes it will be convenient to just export the XML document into simple DOM format, which is a 3-element tuple including the tag name, attributes, and a list of its children. Saxy.SimpleForm module has this nicely supported: Saxy.SimpleForm . parse_string ( data ) { &quot;menu&quot; , [ ] , [ { &quot;movie&quot; , [ { &quot;id&quot; , &quot;tt0120338&quot; } , { &quot;url&quot; , &quot;https://www.imdb.com/title/tt0120338/&quot; } ] , [ { &quot;name&quot; , [ ] , [ &quot;Titanic&quot; ] } , { &quot;characters&quot; , [ ] , [ &quot;Jack &amp;amp; Rose&quot; ] } ] } , { &quot;movie&quot; , [ { &quot;id&quot; , &quot;tt0109830&quot; } , { &quot;url&quot; , &quot;https://www.imdb.com/title/tt0109830/&quot; } ] , [ { &quot;name&quot; , [ ] , [ &quot;Forest Gump&quot; ] } , { &quot;characters&quot; , [ ] , [ &quot;Forest &amp;amp; Jenny&quot; ] } ] } ] } XML builder Saxy offers two APIs to build simple form and encode XML document. Use Saxy.XML to build and compose XML simple form, then Saxy.encode!/2 to encode the built element into XML binary. iex&gt; import Saxy.XML iex&gt; element = element ( &quot;person&quot; , [ gender : &quot;female&quot; ] , &quot;Alice&quot; ) { &quot;person&quot; , [ { &quot;gender&quot; , &quot;female&quot; } ] , [ { :characters , &quot;Alice&quot; } ] } iex&gt; Saxy . encode! ( element , [ ] ) &quot;&lt;?xml version= \\&quot; 1.0 \\&quot; ?&gt;&lt;person gender= \\&quot; female \\&quot; &gt;Alice&lt;/person&gt;&quot; See Saxy.XML for more XML building APIs. Saxy also provides Saxy.Builder protocol to help composing structs into simple form. defmodule Person do @derive { Saxy.Builder , name : &quot;person&quot; , attributes : [ :gender ] , children : [ :name ] } defstruct [ :gender , :name ] end iex&gt; jack = % Person { gender : :male , name : &quot;Jack&quot; } iex&gt; john = % Person { gender : :male , name : &quot;John&quot; } iex&gt; import Saxy.XML iex&gt; root = element ( &quot;people&quot; , [ ] , [ jack , john ] ) iex&gt; Saxy . encode! ( root , [ ] ) &quot;&lt;?xml version= \\&quot; 1.0 \\&quot; ?&gt;&lt;people&gt;&lt;person gender= \\&quot; male \\&quot; &gt;Jack&lt;/person&gt;&lt;person gender= \\&quot; male \\&quot; &gt;John&lt;/person&gt;&lt;/people&gt;&quot;","ref":"readme.html#overview","title":"Saxy - Overview","type":"extras"},{"doc":"Saxy sounds cool! But I just wanted to quickly convert some XMLs into maps/JSON... Saxy does not have offer XML to maps conversion, because many awesome people already made it happen 💪: https://github.com/bennyhat/xml_json https://github.com/xinz/sax_map Alternatively, this pull request could serve as a good reference if you want to implement your own map-based handler. Does Saxy work with XPath? Saxy in its core is a SAX parser, therefore Saxy does not, and likely will not, offer any XPath functionality. SweetXml is a wonderful library to work with XPath. However, :xmerl , the library used by SweetXml, is not always memory efficient and speedy. You can combine the best of both sides with Saxmerl , which is a Saxy extension converting XML documents into SweetXml compatible format. Please check that library out for more information. Saxy! Where did the name come from? Sa Xi, pronounced like sa-see , is an awesome soft drink made by Chuong Duong .","ref":"readme.html#faqs-with-saxy-xmls","title":"Saxy - FAQs with Saxy/XMLs","type":"extras"},{"doc":"Note that benchmarking XML parsers is difficult and highly depends on the complexity of the documents being parsed. Event I try hard to make the benchmarking suite fair but it's hard to avoid biases when choosing the documents to benchmark against. Therefore the conclusion in this section is only for reference purpose. Please feel free to benchmark against your target documents. The benchmark suite can be found in bench/ . A rule of thumb is that we should compare apple to apple. Some XML parsers target only specific types of XML. Therefore some indicators are provided in the test suite to let know of the fairness of the benchmark results. Some quick and biased conclusions from the benchmark suite: For SAX parser, Saxy is usually 1.4 times faster than Erlsom . With deeply nested documents, Saxy is noticeably faster (4 times faster). For XML builder and encoding, Saxy is usually 10 to 30 times faster than XML Builder . With deeply nested documents, it could be 180 times faster. Saxy significantly uses less memory than XML Builder (4 times to 25 times). Saxy significantly uses less memory than Xmerl, Erlsom and Exomler (1.4 times 10 times).","ref":"readme.html#benchmarking","title":"Saxy - Benchmarking","type":"extras"},{"doc":"No XSD supported. No DTD supported, when Saxy encounters a &lt;!DOCTYPE , it skips that. Only support UTF-8 encoding.","ref":"readme.html#limitations","title":"Saxy - Limitations","type":"extras"},{"doc":"If you have any issues or ideas, feel free to write to https://github.com/qcam/saxy/issues. To start developing: Fork the repository. Write your code and related tests. Create a pull request at https://github.com/qcam/saxy/pulls.","ref":"readme.html#contributing","title":"Saxy - Contributing","type":"extras"},{"doc":"Copyright (c) 2018 Cẩm Huỳnh This software is licensed under the MIT license .","ref":"readme.html#copyright-and-license","title":"Saxy - Copyright and License","type":"extras"},{"doc":"Getting started with SAX This guide is an introduction of how you could parse a XML document in SAX mode with Saxy.","ref":"getting-started-with-sax.html","title":"Getting started with SAX","type":"extras"},{"doc":"SAX is an event driven algorithm to parse XML documents, which means that during parsing, a SAX parser will emit any meaningful data of the document such as start tag to a pre-configured handler, then the handler decides how to process with the emitted data. SAX is especially useful when it comes to large file parsing, because unlike DOM parsing, it does not require fitting the whole parsed document into memory (for XPath operations for example). Parsing in SAX mode is efficient, but it would take some time to get used to. This guide is here to help you get over it.","ref":"getting-started-with-sax.html#sax-simple-api-for-xml","title":"Getting started with SAX - SAX (Simple API for XML)","type":"extras"},{"doc":"Given a XML document as below needs to be parsed, and the desired outcome will be a list of foods with name, price and description. &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;breakfast_menu&gt; &lt;food&gt; &lt;name&gt;Belgian Waffles&lt;/name&gt; &lt;price&gt;$5.95&lt;/price&gt; &lt;description&gt;Two of our famous Belgian Waffles with plenty of real maple syrup&lt;/description&gt; &lt;/food&gt; &lt;food&gt; &lt;name&gt;Strawberry Belgian Waffles&lt;/name&gt; &lt;price&gt;$7.95&lt;/price&gt; &lt;description&gt;Light Belgian waffles covered with strawberries and whipped cream&lt;/description&gt; &lt;/food&gt; &lt;/breakfast_menu&gt; To parse a XML document the SAX way with Saxy, first you need to implement a handler. Let's start with handling the start and end events of the document. No action to take here, we simply return whatever passed in. defmodule FoodHandler do @behaviour Saxy.Handler def handle_event ( :start_document , _prolog , state ) do { :ok , state } end def handle_event ( :end_document , _ , state ) do { :ok , state } end end Next we will be handling the &lt;food&gt; element. The action will be very simple as well. When &lt;food&gt; element starts, we put a new struct into the food list. When &lt;food&gt; element ends, we do nothing but return the list. To make it clear, let's call the state foods instead of state . defmodule FoodHandler do @behaviour Saxy.Handler def handle_event ( :start_element , { name , _attributes } , foods ) do if name == &quot;food&quot; do { :ok , [ % Food { } | foods ] } else { :ok , foods } end end def handle_event ( :end_document , _data , foods ) do { :ok , foods } end end Now we shall start handling &lt;name&gt; and its content. But we encounter a problem: :characters event, which we are supposed to get &quot;Belgian Waffles&quot; for the first food name does not include which tag it belongs to. So we need to somehow cache the current tag that is being parsed, let's revise our handler a little bit. def handle_event ( :start_element , { tag_name , _attributes } , { current_tag , foods } ) do if tag_name == &quot;food&quot; do foods = [ % Food { } | foods ] { :ok , { tag_name , foods } } else { :ok , { tag_name , foods } } end end With this now we can import the content of &quot;name&quot;, and probably other food properties too. def handle_event ( :characters , content , { current_tag , foods } ) do [ current_food | foods ] = foods food = case current_tag do &quot;name&quot; -&gt; Map . put ( current_food , :name , content ) &quot;price&quot; -&gt; Map . put ( current_food , :price , content ) &quot;description&quot; -&gt; Map . put ( current_food , :description , content ) _other -&gt; current_food end { :ok , { &quot;food&quot; , [ food | foods ] } } end As now we have implemented the event handler, it is time to parse the document. document = File . read! ( &quot;/path/to/the/file&quot; ) Saxy . parse_string ( document , { nil , [ ] } , FoodHandler ) { :ok , [ % Food { name : &quot;Belgian Waffles&quot; , price : &quot;$5.95&quot; , description : &quot;Two of our famous Belgian Waffles with plenty of real maple syrup&quot; } , % Food { name : &quot;Strawberry Belgian Waffles&quot; , price : &quot;$7.95&quot; , description : &quot;Light Belgian waffles covered with strawberries and whipped cream&quot; } , ] }","ref":"getting-started-with-sax.html#implement-the-handler","title":"Getting started with SAX - Implement the handler","type":"extras"}]